/* Esame 20 settembre '99 - parte 1 */

#include <stdio.h>
#include <stdlib.h>

#define MAX 30

typedef struct node *tree;

struct node
{
  int el;
  tree left,right;
};

tree empty()
{
  return NULL;
}  


void insert(int i, tree *t)
{
  if (*t==empty()) /* caso base: albero vuoto */
    {
      *t=(tree) malloc(sizeof(struct node));
      (*t)->el=i;
      (*t)->left=empty();
      (*t)->right=empty();
    }
  else if (i<(*t)->el) /* passo induttivo, sottoalbero sinistro */
    insert(i,&((*t)->left));
  else if (i>(*t)->el) /* passo induttivo, sottoalbero destro */
    insert(i,&((*t)->right));

/* nota bene: nel caso i==(*t)->el non fa nulla! */		
}   


void print(tree t)
{
  if (t!=empty()) /* se l'albero e` vuoto non stampo nulla */
    {
      print(t->left);
      printf(" %d",t->el);
      print(t->right);
    }
}

int main(void)
{
  char fname[MAX];
  tree t=empty();
  FILE *fd=NULL;
  int i;

  printf("Enter file name: ");
  scanf("%s",fname);
  if (fd=fopen(fname,"r"))
    {
      while (fscanf(fd,"%d",&i)==1 && i!=-1)
	  insert(i,&t);
      printf("Tree from file %s: ",fname);
      print(t);
      printf("\n");
    }
  else
    printf("Error opening file %s\n",fname);
 fclose(fd);   
}
